-- GuildKeys.lua
-- Author: KiLLerBoy_001

--Globals 
local Debug = false  
local loaded = false
local Prefix = "GK"
local NextSend = 0
local NeedSend = false

local function Debugprint(str) 
	if Debug then 
		print("|cFFF49242DEBUG: |cFFE3DEDB"..str)
	end 
end

local function BooltoStr(Bool)
	if Bool == true then 
		return "|cFF4ef442Enabled"
	else
		return "|cFFf44141Disabled"
	end
end

local function toggle(bool)
	if bool == false then 
		return true 
	else 
		return false 
	end
end 

local function getBoolean(val)
	if val then
		return true
	else
		return false
	end
end


--Functions 
local function LoadSettings()
	if loaded == false then
		C_ChatInfo.RegisterAddonMessagePrefix("GK")
		if GuildKeysVar == nil then
			GuildKeysVar = {}
		end
		
		print("|cFFD4AF37[GuildKeys]|cFFE3DEDB Loaded...")
		loaded = true
	end
end 

local function SendData()
	if GetTime()> NextSend then
		for key,value in pairs(GuildKeysVar) do
			C_ChatInfo.SendAddonMessage(Prefix, key.."*"..value, "GUILD")
		end	
		if Debug then print("|cFFD4AF37[GuildKeys]|cFFE3DEDB Debug: Send was completed") end
		NextSend = GetTime()+120
		return true
	else
		if Debug then print("|cFFD4AF37[GuildKeys]|cFFE3DEDB Debug: Send was attempted but blocked cause timeout") end
		return false
	end
end

local function CheckForOldKeys()
	local Now = tonumber(date("%y%m%d"))
	local day = tonumber(date("%u"))
	
	if day == 3 then --Wednesday
		for key,value in pairs(GuildKeysVar) do
			local Key, YMD = strsplit("*",value,2)
			if tonumber(YMD) < Now then 
				GuildKeysVar[key] = nil
			end
		end 
	elseif day == 4 then --Thursday
		for key,value in pairs(GuildKeysVar) do
			local Key, YMD = strsplit("*",value,2)
			if tonumber(YMD) < Now-1 then 
				GuildKeysVar[key] = nil
			end
		end 	
	elseif day == 5 then --Friday
		for key,value in pairs(GuildKeysVar) do
			local Key, YMD = strsplit("*",value,2)
			if tonumber(YMD) < Now-2 then 
				GuildKeysVar[key] = nil
			end
		end	
	elseif day == 6 then --Saturday
		for key,value in pairs(GuildKeysVar) do
			local Key, YMD = strsplit("*",value,2)
			if tonumber(YMD) < Now-3 then 
				GuildKeysVar[key] = nil
			end
		end
	elseif day == 7 then --Sunday
		for key,value in pairs(GuildKeysVar) do
			local Key, YMD = strsplit("*",value,2)
			if tonumber(YMD) < Now-4 then 
				GuildKeysVar[key] = nil
			end
		end
	elseif day == 1 then --Monday
		for key,value in pairs(GuildKeysVar) do
			local Key, YMD = strsplit("*",value,2)
			if tonumber(YMD) < Now-5 then 
				GuildKeysVar[key] = nil
			end
		end
	elseif day == 2 then --Tuesday
		for key,value in pairs(GuildKeysVar) do
			local Key, YMD = strsplit("*",value,2)
			if tonumber(YMD) < Now-6 then 
				GuildKeysVar[key] = nil
			end
		end		
	end
end

local function CheckMykey()
    for bag=0,NUM_BAG_SLOTS do
        for slot=1,GetContainerNumSlots(bag) do
			item = GetContainerItemID(bag,slot)
            if item == 158923 then
                itemLink = GetContainerItemLink(bag, slot)
            end
        end
    end
	if itemLink == nil then 
		itemLink = "|cFFFFFF00[No Key]|cFFE3DEDB"
	end
	if Debug then print("|cFFD4AF37[GuildKeys]|cFFE3DEDB Found current key "..itemLink) end
	local name, realm = UnitFullName("player")
	if realm == nil then 
		
	else
		NameRealm = name.."-"..realm
		YMD = date("%y%m%d")
		GuildKeysVar[NameRealm] = itemLink.."*"..YMD
		SendData()
		CheckForOldKeys()
	end
end 

local function ClearTable()
	for key,value in pairs(GuildKeysVar) do
		GuildKeysVar[key] = nil
	end
end 

--Recieve message
local function OnEvent(self, event, prefix, message, channel, sender)
	if prefix == Prefix then
		if Debug then print("Recieved: "..message.." From: "..sender) end
		local Owner, Key, YMD = strsplit("*",message,3)
		
		if sender == Owner then
			GuildKeysVar[Owner] = Key.."*"..YMD
		elseif GuildKeysVar[Owner] == nil then
			GuildKeysVar[Owner] = Key.."*"..YMD
		else
			local CurKey, CurYMD = strsplit("*",GuildKeysVar[Owner],2)
			if not CurYMB==nil and not YMD==nil then 
				if tonumber(CurYMB) < tonumber(YMD) then
					GuildKeysVar[Owner] = Key.."*"..YMD
				end
			end
		end
	end 
end 

local function Update()
	if NeedSend then 
		if SendData() == true then 
			NeedSend = false
		end
	end 
end

local function EventSelect(self, event, addonName, ...)
	if event == "ADDON_LOADED" then 
		LoadSettings()
	elseif event == "CHALLENGE_MODE_MAPS_UPDATE" or "CHALLENGE_MODE_KEYSTONE_RECEPTABLE_OPEN" or "MYTHIC_PLUS_CURRENT_AFFIX_UPDATE" or "MYTHIC_PLUS_NEW_WEEKLY_RECORD" or "BAG_UPDATE" then 
		CheckMykey()
	elseif event == "PLAYER_ENTERING_WORLD" or "GUILD_ROSTER_UPDATE" then 
		SendData()
		CheckForOldKeys()
	--elseif event == "CHALLENGE_MODE_RESET" then 
		--ClearTable()
		--print("|cFFD4AF37[GuildKeys]|cFFE3DEDB Resetting stored data cause Reset";
	end
end

RecieveFrame = CreateFrame("Frame");
RecieveFrame:RegisterEvent("CHAT_MSG_ADDON");
RecieveFrame:SetScript("OnEvent", OnEvent)

MainFrame = CreateFrame('Frame')
MainFrame:RegisterEvent("ADDON_LOADED")
MainFrame:RegisterEvent("PLAYER_ENTERING_WORLD")
MainFrame:RegisterEvent("CHALLENGE_MODE_MAPS_UPDATE")
MainFrame:RegisterEvent("CHALLENGE_MODE_KEYSTONE_RECEPTABLE_OPEN")
MainFrame:RegisterEvent("MYTHIC_PLUS_CURRENT_AFFIX_UPDATE")
MainFrame:RegisterEvent("MYTHIC_PLUS_NEW_WEEKLY_RECORD")
MainFrame:RegisterEvent("GUILD_ROSTER_UPDATE")
MainFrame:RegisterEvent("BAG_UPDATE")
--MainFrame:RegisterEvent("CHALLENGE_MODE_RESET")
MainFrame:SetScript('OnEvent', EventSelect)
MainFrame:SetScript('OnUpdate', Update)




SLASH_GK1, SLASH_GK2 = '/guildkeys', '/gk';
local function handler(msg, editbox)
	local command, str = msg:match("^(%S*)%s*(.-)$");
	if command == 'debug' then
		Debug =toggle(Debug)
		print("|cFFD4AF37[GuildKeys]|cFFE3DEDB Debug: "..BooltoStr(Debug));
	elseif command == 'old'then 
		CheckForOldKeys()
	elseif command == 'send'then 
		for key,value in pairs(GuildKeysVar) do
			C_ChatInfo.SendAddonMessage(Prefix, key.."*"..value, "GUILD")
		end
		print("|cFFD4AF37[GuildKeys]|cFFE3DEDB Force send completed")
		
	elseif command == 'list' then
		print("|cFFD4AF37[GuildKeys]|cFFE3DEDB ---- LISTING ARCHIVED KEYS ----")
		print("|cFFD4AF37[GK]|cFFE3DEDB ----")
		for key,value in pairs(GuildKeysVar) do
			local Key, YMD = strsplit("*",GuildKeysVar[key],2)
			print("|cFFD4AF37[GK]|cFFE3DEDB "..key.." Has: "..Key)
		end
		print("|cFFD4AF37[GK]|cFFE3DEDB ----")
		print("|cFFD4AF37[GuildKeys]|cFFE3DEDB ---- END OF LISTING ----")
		
	else 
		print("|cFFD4AF37[GuildKeys]|cFFE3DEDB Command not recognized")
		
	end
end
SlashCmdList["GK"] = handler; -- Also a valid assignment strategy
